"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserializeAws_restJson1ListDetectorsCommand = exports.deserializeAws_restJson1ListAlarmsCommand = exports.deserializeAws_restJson1DescribeDetectorCommand = exports.deserializeAws_restJson1DescribeAlarmCommand = exports.deserializeAws_restJson1BatchUpdateDetectorCommand = exports.deserializeAws_restJson1BatchSnoozeAlarmCommand = exports.deserializeAws_restJson1BatchResetAlarmCommand = exports.deserializeAws_restJson1BatchPutMessageCommand = exports.deserializeAws_restJson1BatchEnableAlarmCommand = exports.deserializeAws_restJson1BatchDisableAlarmCommand = exports.deserializeAws_restJson1BatchAcknowledgeAlarmCommand = exports.serializeAws_restJson1ListDetectorsCommand = exports.serializeAws_restJson1ListAlarmsCommand = exports.serializeAws_restJson1DescribeDetectorCommand = exports.serializeAws_restJson1DescribeAlarmCommand = exports.serializeAws_restJson1BatchUpdateDetectorCommand = exports.serializeAws_restJson1BatchSnoozeAlarmCommand = exports.serializeAws_restJson1BatchResetAlarmCommand = exports.serializeAws_restJson1BatchPutMessageCommand = exports.serializeAws_restJson1BatchEnableAlarmCommand = exports.serializeAws_restJson1BatchDisableAlarmCommand = exports.serializeAws_restJson1BatchAcknowledgeAlarmCommand = void 0;
const protocol_http_1 = require("@aws-sdk/protocol-http");
const smithy_client_1 = require("@aws-sdk/smithy-client");
const IoTEventsDataServiceException_1 = require("../models/IoTEventsDataServiceException");
const models_0_1 = require("../models/models_0");
const serializeAws_restJson1BatchAcknowledgeAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/acknowledge";
    let body;
    body = JSON.stringify({
        ...(input.acknowledgeActionRequests !== undefined &&
            input.acknowledgeActionRequests !== null && {
            acknowledgeActionRequests: serializeAws_restJson1AcknowledgeAlarmActionRequests(input.acknowledgeActionRequests, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchAcknowledgeAlarmCommand = serializeAws_restJson1BatchAcknowledgeAlarmCommand;
const serializeAws_restJson1BatchDisableAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/disable";
    let body;
    body = JSON.stringify({
        ...(input.disableActionRequests !== undefined &&
            input.disableActionRequests !== null && {
            disableActionRequests: serializeAws_restJson1DisableAlarmActionRequests(input.disableActionRequests, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchDisableAlarmCommand = serializeAws_restJson1BatchDisableAlarmCommand;
const serializeAws_restJson1BatchEnableAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/enable";
    let body;
    body = JSON.stringify({
        ...(input.enableActionRequests !== undefined &&
            input.enableActionRequests !== null && {
            enableActionRequests: serializeAws_restJson1EnableAlarmActionRequests(input.enableActionRequests, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchEnableAlarmCommand = serializeAws_restJson1BatchEnableAlarmCommand;
const serializeAws_restJson1BatchPutMessageCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/inputs/messages";
    let body;
    body = JSON.stringify({
        ...(input.messages !== undefined &&
            input.messages !== null && { messages: serializeAws_restJson1Messages(input.messages, context) }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchPutMessageCommand = serializeAws_restJson1BatchPutMessageCommand;
const serializeAws_restJson1BatchResetAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/reset";
    let body;
    body = JSON.stringify({
        ...(input.resetActionRequests !== undefined &&
            input.resetActionRequests !== null && {
            resetActionRequests: serializeAws_restJson1ResetAlarmActionRequests(input.resetActionRequests, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchResetAlarmCommand = serializeAws_restJson1BatchResetAlarmCommand;
const serializeAws_restJson1BatchSnoozeAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/snooze";
    let body;
    body = JSON.stringify({
        ...(input.snoozeActionRequests !== undefined &&
            input.snoozeActionRequests !== null && {
            snoozeActionRequests: serializeAws_restJson1SnoozeAlarmActionRequests(input.snoozeActionRequests, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchSnoozeAlarmCommand = serializeAws_restJson1BatchSnoozeAlarmCommand;
const serializeAws_restJson1BatchUpdateDetectorCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {
        "content-type": "application/json",
    };
    const resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/detectors";
    let body;
    body = JSON.stringify({
        ...(input.detectors !== undefined &&
            input.detectors !== null && {
            detectors: serializeAws_restJson1UpdateDetectorRequests(input.detectors, context),
        }),
    });
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "POST",
        headers,
        path: resolvedPath,
        body,
    });
};
exports.serializeAws_restJson1BatchUpdateDetectorCommand = serializeAws_restJson1BatchUpdateDetectorCommand;
const serializeAws_restJson1DescribeAlarmCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/{alarmModelName}/keyValues";
    if (input.alarmModelName !== undefined) {
        const labelValue = input.alarmModelName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: alarmModelName.");
        }
        resolvedPath = resolvedPath.replace("{alarmModelName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: alarmModelName.");
    }
    const query = {
        ...(input.keyValue !== undefined && { keyValue: input.keyValue }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeAlarmCommand = serializeAws_restJson1DescribeAlarmCommand;
const serializeAws_restJson1DescribeDetectorCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/detectors/{detectorModelName}/keyValues";
    if (input.detectorModelName !== undefined) {
        const labelValue = input.detectorModelName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: detectorModelName.");
        }
        resolvedPath = resolvedPath.replace("{detectorModelName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: detectorModelName.");
    }
    const query = {
        ...(input.keyValue !== undefined && { keyValue: input.keyValue }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1DescribeDetectorCommand = serializeAws_restJson1DescribeDetectorCommand;
const serializeAws_restJson1ListAlarmsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/alarms/{alarmModelName}";
    if (input.alarmModelName !== undefined) {
        const labelValue = input.alarmModelName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: alarmModelName.");
        }
        resolvedPath = resolvedPath.replace("{alarmModelName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: alarmModelName.");
    }
    const query = {
        ...(input.nextToken !== undefined && { nextToken: input.nextToken }),
        ...(input.maxResults !== undefined && { maxResults: input.maxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListAlarmsCommand = serializeAws_restJson1ListAlarmsCommand;
const serializeAws_restJson1ListDetectorsCommand = async (input, context) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const headers = {};
    let resolvedPath = `${(basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || ""}` + "/detectors/{detectorModelName}";
    if (input.detectorModelName !== undefined) {
        const labelValue = input.detectorModelName;
        if (labelValue.length <= 0) {
            throw new Error("Empty value provided for input HTTP label: detectorModelName.");
        }
        resolvedPath = resolvedPath.replace("{detectorModelName}", (0, smithy_client_1.extendedEncodeURIComponent)(labelValue));
    }
    else {
        throw new Error("No value provided for input HTTP label: detectorModelName.");
    }
    const query = {
        ...(input.stateName !== undefined && { stateName: input.stateName }),
        ...(input.nextToken !== undefined && { nextToken: input.nextToken }),
        ...(input.maxResults !== undefined && { maxResults: input.maxResults.toString() }),
    };
    let body;
    return new protocol_http_1.HttpRequest({
        protocol,
        hostname,
        port,
        method: "GET",
        headers,
        path: resolvedPath,
        query,
        body,
    });
};
exports.serializeAws_restJson1ListDetectorsCommand = serializeAws_restJson1ListDetectorsCommand;
const deserializeAws_restJson1BatchAcknowledgeAlarmCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchAcknowledgeAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        errorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.errorEntries !== undefined && data.errorEntries !== null) {
        contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchAcknowledgeAlarmCommand = deserializeAws_restJson1BatchAcknowledgeAlarmCommand;
const deserializeAws_restJson1BatchAcknowledgeAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchDisableAlarmCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchDisableAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        errorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.errorEntries !== undefined && data.errorEntries !== null) {
        contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchDisableAlarmCommand = deserializeAws_restJson1BatchDisableAlarmCommand;
const deserializeAws_restJson1BatchDisableAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchEnableAlarmCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchEnableAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        errorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.errorEntries !== undefined && data.errorEntries !== null) {
        contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchEnableAlarmCommand = deserializeAws_restJson1BatchEnableAlarmCommand;
const deserializeAws_restJson1BatchEnableAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchPutMessageCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchPutMessageCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        BatchPutMessageErrorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.BatchPutMessageErrorEntries !== undefined && data.BatchPutMessageErrorEntries !== null) {
        contents.BatchPutMessageErrorEntries = deserializeAws_restJson1BatchPutMessageErrorEntries(data.BatchPutMessageErrorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchPutMessageCommand = deserializeAws_restJson1BatchPutMessageCommand;
const deserializeAws_restJson1BatchPutMessageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchResetAlarmCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchResetAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        errorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.errorEntries !== undefined && data.errorEntries !== null) {
        contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchResetAlarmCommand = deserializeAws_restJson1BatchResetAlarmCommand;
const deserializeAws_restJson1BatchResetAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchSnoozeAlarmCommand = async (output, context) => {
    if (output.statusCode !== 202 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchSnoozeAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        errorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.errorEntries !== undefined && data.errorEntries !== null) {
        contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchSnoozeAlarmCommand = deserializeAws_restJson1BatchSnoozeAlarmCommand;
const deserializeAws_restJson1BatchSnoozeAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1BatchUpdateDetectorCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1BatchUpdateDetectorCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        batchUpdateDetectorErrorEntries: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.batchUpdateDetectorErrorEntries !== undefined && data.batchUpdateDetectorErrorEntries !== null) {
        contents.batchUpdateDetectorErrorEntries = deserializeAws_restJson1BatchUpdateDetectorErrorEntries(data.batchUpdateDetectorErrorEntries, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1BatchUpdateDetectorCommand = deserializeAws_restJson1BatchUpdateDetectorCommand;
const deserializeAws_restJson1BatchUpdateDetectorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeAlarmCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeAlarmCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        alarm: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.alarm !== undefined && data.alarm !== null) {
        contents.alarm = deserializeAws_restJson1Alarm(data.alarm, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeAlarmCommand = deserializeAws_restJson1DescribeAlarmCommand;
const deserializeAws_restJson1DescribeAlarmCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.ioteventsdata#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1DescribeDetectorCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1DescribeDetectorCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        detector: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.detector !== undefined && data.detector !== null) {
        contents.detector = deserializeAws_restJson1Detector(data.detector, context);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1DescribeDetectorCommand = deserializeAws_restJson1DescribeDetectorCommand;
const deserializeAws_restJson1DescribeDetectorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.ioteventsdata#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListAlarmsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListAlarmsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        alarmSummaries: undefined,
        nextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.alarmSummaries !== undefined && data.alarmSummaries !== null) {
        contents.alarmSummaries = deserializeAws_restJson1AlarmSummaries(data.alarmSummaries, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.nextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListAlarmsCommand = deserializeAws_restJson1ListAlarmsCommand;
const deserializeAws_restJson1ListAlarmsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.ioteventsdata#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1ListDetectorsCommand = async (output, context) => {
    if (output.statusCode !== 200 && output.statusCode >= 300) {
        return deserializeAws_restJson1ListDetectorsCommandError(output, context);
    }
    const contents = {
        $metadata: deserializeMetadata(output),
        detectorSummaries: undefined,
        nextToken: undefined,
    };
    const data = (0, smithy_client_1.expectNonNull)((0, smithy_client_1.expectObject)(await parseBody(output.body, context)), "body");
    if (data.detectorSummaries !== undefined && data.detectorSummaries !== null) {
        contents.detectorSummaries = deserializeAws_restJson1DetectorSummaries(data.detectorSummaries, context);
    }
    if (data.nextToken !== undefined && data.nextToken !== null) {
        contents.nextToken = (0, smithy_client_1.expectString)(data.nextToken);
    }
    return Promise.resolve(contents);
};
exports.deserializeAws_restJson1ListDetectorsCommand = deserializeAws_restJson1ListDetectorsCommand;
const deserializeAws_restJson1ListDetectorsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    let response;
    let errorCode = "UnknownError";
    errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalFailureException":
        case "com.amazonaws.ioteventsdata#InternalFailureException":
            throw await deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context);
        case "InvalidRequestException":
        case "com.amazonaws.ioteventsdata#InvalidRequestException":
            throw await deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.ioteventsdata#ResourceNotFoundException":
            throw await deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceUnavailableException":
        case "com.amazonaws.ioteventsdata#ServiceUnavailableException":
            throw await deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context);
        case "ThrottlingException":
        case "com.amazonaws.ioteventsdata#ThrottlingException":
            throw await deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            response = new IoTEventsDataServiceException_1.IoTEventsDataServiceException({
                name: parsedBody.code || parsedBody.Code || errorCode,
                $fault: "client",
                $metadata: deserializeMetadata(output),
            });
            throw (0, smithy_client_1.decorateServiceException)(response, parsedBody);
    }
};
const deserializeAws_restJson1InternalFailureExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.InternalFailureException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1InvalidRequestExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.InvalidRequestException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ServiceUnavailableExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ServiceUnavailableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const deserializeAws_restJson1ThrottlingExceptionResponse = async (parsedOutput, context) => {
    const contents = {};
    const data = parsedOutput.body;
    if (data.message !== undefined && data.message !== null) {
        contents.message = (0, smithy_client_1.expectString)(data.message);
    }
    const exception = new models_0_1.ThrottlingException({
        $metadata: deserializeMetadata(parsedOutput),
        ...contents,
    });
    return (0, smithy_client_1.decorateServiceException)(exception, parsedOutput.body);
};
const serializeAws_restJson1AcknowledgeAlarmActionRequest = (input, context) => {
    return {
        ...(input.alarmModelName !== undefined &&
            input.alarmModelName !== null && { alarmModelName: input.alarmModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.note !== undefined && input.note !== null && { note: input.note }),
        ...(input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }),
    };
};
const serializeAws_restJson1AcknowledgeAlarmActionRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1AcknowledgeAlarmActionRequest(entry, context);
    });
};
const serializeAws_restJson1DetectorStateDefinition = (input, context) => {
    return {
        ...(input.stateName !== undefined && input.stateName !== null && { stateName: input.stateName }),
        ...(input.timers !== undefined &&
            input.timers !== null && { timers: serializeAws_restJson1TimerDefinitions(input.timers, context) }),
        ...(input.variables !== undefined &&
            input.variables !== null && { variables: serializeAws_restJson1VariableDefinitions(input.variables, context) }),
    };
};
const serializeAws_restJson1DisableAlarmActionRequest = (input, context) => {
    return {
        ...(input.alarmModelName !== undefined &&
            input.alarmModelName !== null && { alarmModelName: input.alarmModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.note !== undefined && input.note !== null && { note: input.note }),
        ...(input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }),
    };
};
const serializeAws_restJson1DisableAlarmActionRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1DisableAlarmActionRequest(entry, context);
    });
};
const serializeAws_restJson1EnableAlarmActionRequest = (input, context) => {
    return {
        ...(input.alarmModelName !== undefined &&
            input.alarmModelName !== null && { alarmModelName: input.alarmModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.note !== undefined && input.note !== null && { note: input.note }),
        ...(input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }),
    };
};
const serializeAws_restJson1EnableAlarmActionRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1EnableAlarmActionRequest(entry, context);
    });
};
const serializeAws_restJson1Message = (input, context) => {
    return {
        ...(input.inputName !== undefined && input.inputName !== null && { inputName: input.inputName }),
        ...(input.messageId !== undefined && input.messageId !== null && { messageId: input.messageId }),
        ...(input.payload !== undefined && input.payload !== null && { payload: context.base64Encoder(input.payload) }),
        ...(input.timestamp !== undefined &&
            input.timestamp !== null && { timestamp: serializeAws_restJson1TimestampValue(input.timestamp, context) }),
    };
};
const serializeAws_restJson1Messages = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1Message(entry, context);
    });
};
const serializeAws_restJson1ResetAlarmActionRequest = (input, context) => {
    return {
        ...(input.alarmModelName !== undefined &&
            input.alarmModelName !== null && { alarmModelName: input.alarmModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.note !== undefined && input.note !== null && { note: input.note }),
        ...(input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }),
    };
};
const serializeAws_restJson1ResetAlarmActionRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1ResetAlarmActionRequest(entry, context);
    });
};
const serializeAws_restJson1SnoozeAlarmActionRequest = (input, context) => {
    return {
        ...(input.alarmModelName !== undefined &&
            input.alarmModelName !== null && { alarmModelName: input.alarmModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.note !== undefined && input.note !== null && { note: input.note }),
        ...(input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }),
        ...(input.snoozeDuration !== undefined &&
            input.snoozeDuration !== null && { snoozeDuration: input.snoozeDuration }),
    };
};
const serializeAws_restJson1SnoozeAlarmActionRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1SnoozeAlarmActionRequest(entry, context);
    });
};
const serializeAws_restJson1TimerDefinition = (input, context) => {
    return {
        ...(input.name !== undefined && input.name !== null && { name: input.name }),
        ...(input.seconds !== undefined && input.seconds !== null && { seconds: input.seconds }),
    };
};
const serializeAws_restJson1TimerDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1TimerDefinition(entry, context);
    });
};
const serializeAws_restJson1TimestampValue = (input, context) => {
    return {
        ...(input.timeInMillis !== undefined && input.timeInMillis !== null && { timeInMillis: input.timeInMillis }),
    };
};
const serializeAws_restJson1UpdateDetectorRequest = (input, context) => {
    return {
        ...(input.detectorModelName !== undefined &&
            input.detectorModelName !== null && { detectorModelName: input.detectorModelName }),
        ...(input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue }),
        ...(input.messageId !== undefined && input.messageId !== null && { messageId: input.messageId }),
        ...(input.state !== undefined &&
            input.state !== null && { state: serializeAws_restJson1DetectorStateDefinition(input.state, context) }),
    };
};
const serializeAws_restJson1UpdateDetectorRequests = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1UpdateDetectorRequest(entry, context);
    });
};
const serializeAws_restJson1VariableDefinition = (input, context) => {
    return {
        ...(input.name !== undefined && input.name !== null && { name: input.name }),
        ...(input.value !== undefined && input.value !== null && { value: input.value }),
    };
};
const serializeAws_restJson1VariableDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1VariableDefinition(entry, context);
    });
};
const deserializeAws_restJson1AcknowledgeActionConfiguration = (output, context) => {
    return {
        note: (0, smithy_client_1.expectString)(output.note),
    };
};
const deserializeAws_restJson1Alarm = (output, context) => {
    return {
        alarmModelName: (0, smithy_client_1.expectString)(output.alarmModelName),
        alarmModelVersion: (0, smithy_client_1.expectString)(output.alarmModelVersion),
        alarmState: output.alarmState !== undefined && output.alarmState !== null
            ? deserializeAws_restJson1AlarmState(output.alarmState, context)
            : undefined,
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.creationTime)))
            : undefined,
        keyValue: (0, smithy_client_1.expectString)(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.lastUpdateTime)))
            : undefined,
        severity: (0, smithy_client_1.expectInt32)(output.severity),
    };
};
const deserializeAws_restJson1AlarmState = (output, context) => {
    return {
        customerAction: output.customerAction !== undefined && output.customerAction !== null
            ? deserializeAws_restJson1CustomerAction(output.customerAction, context)
            : undefined,
        ruleEvaluation: output.ruleEvaluation !== undefined && output.ruleEvaluation !== null
            ? deserializeAws_restJson1RuleEvaluation(output.ruleEvaluation, context)
            : undefined,
        stateName: (0, smithy_client_1.expectString)(output.stateName),
        systemEvent: output.systemEvent !== undefined && output.systemEvent !== null
            ? deserializeAws_restJson1SystemEvent(output.systemEvent, context)
            : undefined,
    };
};
const deserializeAws_restJson1AlarmSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AlarmSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1AlarmSummary = (output, context) => {
    return {
        alarmModelName: (0, smithy_client_1.expectString)(output.alarmModelName),
        alarmModelVersion: (0, smithy_client_1.expectString)(output.alarmModelVersion),
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.creationTime)))
            : undefined,
        keyValue: (0, smithy_client_1.expectString)(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.lastUpdateTime)))
            : undefined,
        stateName: (0, smithy_client_1.expectString)(output.stateName),
    };
};
const deserializeAws_restJson1BatchAlarmActionErrorEntries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchAlarmActionErrorEntry(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1BatchAlarmActionErrorEntry = (output, context) => {
    return {
        errorCode: (0, smithy_client_1.expectString)(output.errorCode),
        errorMessage: (0, smithy_client_1.expectString)(output.errorMessage),
        requestId: (0, smithy_client_1.expectString)(output.requestId),
    };
};
const deserializeAws_restJson1BatchPutMessageErrorEntries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchPutMessageErrorEntry(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1BatchPutMessageErrorEntry = (output, context) => {
    return {
        errorCode: (0, smithy_client_1.expectString)(output.errorCode),
        errorMessage: (0, smithy_client_1.expectString)(output.errorMessage),
        messageId: (0, smithy_client_1.expectString)(output.messageId),
    };
};
const deserializeAws_restJson1BatchUpdateDetectorErrorEntries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchUpdateDetectorErrorEntry(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1BatchUpdateDetectorErrorEntry = (output, context) => {
    return {
        errorCode: (0, smithy_client_1.expectString)(output.errorCode),
        errorMessage: (0, smithy_client_1.expectString)(output.errorMessage),
        messageId: (0, smithy_client_1.expectString)(output.messageId),
    };
};
const deserializeAws_restJson1CustomerAction = (output, context) => {
    return {
        acknowledgeActionConfiguration: output.acknowledgeActionConfiguration !== undefined && output.acknowledgeActionConfiguration !== null
            ? deserializeAws_restJson1AcknowledgeActionConfiguration(output.acknowledgeActionConfiguration, context)
            : undefined,
        actionName: (0, smithy_client_1.expectString)(output.actionName),
        disableActionConfiguration: output.disableActionConfiguration !== undefined && output.disableActionConfiguration !== null
            ? deserializeAws_restJson1DisableActionConfiguration(output.disableActionConfiguration, context)
            : undefined,
        enableActionConfiguration: output.enableActionConfiguration !== undefined && output.enableActionConfiguration !== null
            ? deserializeAws_restJson1EnableActionConfiguration(output.enableActionConfiguration, context)
            : undefined,
        resetActionConfiguration: output.resetActionConfiguration !== undefined && output.resetActionConfiguration !== null
            ? deserializeAws_restJson1ResetActionConfiguration(output.resetActionConfiguration, context)
            : undefined,
        snoozeActionConfiguration: output.snoozeActionConfiguration !== undefined && output.snoozeActionConfiguration !== null
            ? deserializeAws_restJson1SnoozeActionConfiguration(output.snoozeActionConfiguration, context)
            : undefined,
    };
};
const deserializeAws_restJson1Detector = (output, context) => {
    return {
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.creationTime)))
            : undefined,
        detectorModelName: (0, smithy_client_1.expectString)(output.detectorModelName),
        detectorModelVersion: (0, smithy_client_1.expectString)(output.detectorModelVersion),
        keyValue: (0, smithy_client_1.expectString)(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.lastUpdateTime)))
            : undefined,
        state: output.state !== undefined && output.state !== null
            ? deserializeAws_restJson1DetectorState(output.state, context)
            : undefined,
    };
};
const deserializeAws_restJson1DetectorState = (output, context) => {
    return {
        stateName: (0, smithy_client_1.expectString)(output.stateName),
        timers: output.timers !== undefined && output.timers !== null
            ? deserializeAws_restJson1Timers(output.timers, context)
            : undefined,
        variables: output.variables !== undefined && output.variables !== null
            ? deserializeAws_restJson1Variables(output.variables, context)
            : undefined,
    };
};
const deserializeAws_restJson1DetectorStateSummary = (output, context) => {
    return {
        stateName: (0, smithy_client_1.expectString)(output.stateName),
    };
};
const deserializeAws_restJson1DetectorSummaries = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1DetectorSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1DetectorSummary = (output, context) => {
    return {
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.creationTime)))
            : undefined,
        detectorModelName: (0, smithy_client_1.expectString)(output.detectorModelName),
        detectorModelVersion: (0, smithy_client_1.expectString)(output.detectorModelVersion),
        keyValue: (0, smithy_client_1.expectString)(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.lastUpdateTime)))
            : undefined,
        state: output.state !== undefined && output.state !== null
            ? deserializeAws_restJson1DetectorStateSummary(output.state, context)
            : undefined,
    };
};
const deserializeAws_restJson1DisableActionConfiguration = (output, context) => {
    return {
        note: (0, smithy_client_1.expectString)(output.note),
    };
};
const deserializeAws_restJson1EnableActionConfiguration = (output, context) => {
    return {
        note: (0, smithy_client_1.expectString)(output.note),
    };
};
const deserializeAws_restJson1ResetActionConfiguration = (output, context) => {
    return {
        note: (0, smithy_client_1.expectString)(output.note),
    };
};
const deserializeAws_restJson1RuleEvaluation = (output, context) => {
    return {
        simpleRuleEvaluation: output.simpleRuleEvaluation !== undefined && output.simpleRuleEvaluation !== null
            ? deserializeAws_restJson1SimpleRuleEvaluation(output.simpleRuleEvaluation, context)
            : undefined,
    };
};
const deserializeAws_restJson1SimpleRuleEvaluation = (output, context) => {
    return {
        inputPropertyValue: (0, smithy_client_1.expectString)(output.inputPropertyValue),
        operator: (0, smithy_client_1.expectString)(output.operator),
        thresholdValue: (0, smithy_client_1.expectString)(output.thresholdValue),
    };
};
const deserializeAws_restJson1SnoozeActionConfiguration = (output, context) => {
    return {
        note: (0, smithy_client_1.expectString)(output.note),
        snoozeDuration: (0, smithy_client_1.expectInt32)(output.snoozeDuration),
    };
};
const deserializeAws_restJson1StateChangeConfiguration = (output, context) => {
    return {
        triggerType: (0, smithy_client_1.expectString)(output.triggerType),
    };
};
const deserializeAws_restJson1SystemEvent = (output, context) => {
    return {
        eventType: (0, smithy_client_1.expectString)(output.eventType),
        stateChangeConfiguration: output.stateChangeConfiguration !== undefined && output.stateChangeConfiguration !== null
            ? deserializeAws_restJson1StateChangeConfiguration(output.stateChangeConfiguration, context)
            : undefined,
    };
};
const deserializeAws_restJson1Timer = (output, context) => {
    return {
        name: (0, smithy_client_1.expectString)(output.name),
        timestamp: output.timestamp !== undefined && output.timestamp !== null
            ? (0, smithy_client_1.expectNonNull)((0, smithy_client_1.parseEpochTimestamp)((0, smithy_client_1.expectNumber)(output.timestamp)))
            : undefined,
    };
};
const deserializeAws_restJson1Timers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Timer(entry, context);
    });
    return retVal;
};
const deserializeAws_restJson1Variable = (output, context) => {
    return {
        name: (0, smithy_client_1.expectString)(output.name),
        value: (0, smithy_client_1.expectString)(output.value),
    };
};
const deserializeAws_restJson1Variables = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Variable(entry, context);
    });
    return retVal;
};
const deserializeMetadata = (output) => {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const isSerializableHeaderValue = (value) => value !== undefined &&
    value !== null &&
    value !== "" &&
    (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
    (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
