import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchAcknowledgeAlarmRequest, BatchAcknowledgeAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchAcknowledgeAlarmCommand, serializeAws_restJson1BatchAcknowledgeAlarmCommand, } from "../protocols/Aws_restJson1";
var BatchAcknowledgeAlarmCommand = (function (_super) {
    __extends(BatchAcknowledgeAlarmCommand, _super);
    function BatchAcknowledgeAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchAcknowledgeAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchAcknowledgeAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchAcknowledgeAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchAcknowledgeAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchAcknowledgeAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchAcknowledgeAlarmCommand(input, context);
    };
    BatchAcknowledgeAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchAcknowledgeAlarmCommand(output, context);
    };
    return BatchAcknowledgeAlarmCommand;
}($Command));
export { BatchAcknowledgeAlarmCommand };
