import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchDisableAlarmRequest, BatchDisableAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchDisableAlarmCommand, serializeAws_restJson1BatchDisableAlarmCommand, } from "../protocols/Aws_restJson1";
var BatchDisableAlarmCommand = (function (_super) {
    __extends(BatchDisableAlarmCommand, _super);
    function BatchDisableAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchDisableAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchDisableAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchDisableAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchDisableAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchDisableAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchDisableAlarmCommand(input, context);
    };
    BatchDisableAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchDisableAlarmCommand(output, context);
    };
    return BatchDisableAlarmCommand;
}($Command));
export { BatchDisableAlarmCommand };
