import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchEnableAlarmRequest, BatchEnableAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchEnableAlarmCommand, serializeAws_restJson1BatchEnableAlarmCommand, } from "../protocols/Aws_restJson1";
var BatchEnableAlarmCommand = (function (_super) {
    __extends(BatchEnableAlarmCommand, _super);
    function BatchEnableAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchEnableAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchEnableAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchEnableAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchEnableAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchEnableAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchEnableAlarmCommand(input, context);
    };
    BatchEnableAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchEnableAlarmCommand(output, context);
    };
    return BatchEnableAlarmCommand;
}($Command));
export { BatchEnableAlarmCommand };
