import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchPutMessageRequest, BatchPutMessageResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchPutMessageCommand, serializeAws_restJson1BatchPutMessageCommand, } from "../protocols/Aws_restJson1";
var BatchPutMessageCommand = (function (_super) {
    __extends(BatchPutMessageCommand, _super);
    function BatchPutMessageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchPutMessageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchPutMessageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchPutMessageRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchPutMessageResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchPutMessageCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchPutMessageCommand(input, context);
    };
    BatchPutMessageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchPutMessageCommand(output, context);
    };
    return BatchPutMessageCommand;
}($Command));
export { BatchPutMessageCommand };
