import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchResetAlarmRequest, BatchResetAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchResetAlarmCommand, serializeAws_restJson1BatchResetAlarmCommand, } from "../protocols/Aws_restJson1";
var BatchResetAlarmCommand = (function (_super) {
    __extends(BatchResetAlarmCommand, _super);
    function BatchResetAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchResetAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchResetAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchResetAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchResetAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchResetAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchResetAlarmCommand(input, context);
    };
    BatchResetAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchResetAlarmCommand(output, context);
    };
    return BatchResetAlarmCommand;
}($Command));
export { BatchResetAlarmCommand };
