import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchSnoozeAlarmRequest, BatchSnoozeAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchSnoozeAlarmCommand, serializeAws_restJson1BatchSnoozeAlarmCommand, } from "../protocols/Aws_restJson1";
var BatchSnoozeAlarmCommand = (function (_super) {
    __extends(BatchSnoozeAlarmCommand, _super);
    function BatchSnoozeAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchSnoozeAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchSnoozeAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchSnoozeAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchSnoozeAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchSnoozeAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchSnoozeAlarmCommand(input, context);
    };
    BatchSnoozeAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchSnoozeAlarmCommand(output, context);
    };
    return BatchSnoozeAlarmCommand;
}($Command));
export { BatchSnoozeAlarmCommand };
