import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { BatchUpdateDetectorRequest, BatchUpdateDetectorResponse } from "../models/models_0";
import { deserializeAws_restJson1BatchUpdateDetectorCommand, serializeAws_restJson1BatchUpdateDetectorCommand, } from "../protocols/Aws_restJson1";
var BatchUpdateDetectorCommand = (function (_super) {
    __extends(BatchUpdateDetectorCommand, _super);
    function BatchUpdateDetectorCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    BatchUpdateDetectorCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "BatchUpdateDetectorCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: BatchUpdateDetectorRequest.filterSensitiveLog,
            outputFilterSensitiveLog: BatchUpdateDetectorResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    BatchUpdateDetectorCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1BatchUpdateDetectorCommand(input, context);
    };
    BatchUpdateDetectorCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1BatchUpdateDetectorCommand(output, context);
    };
    return BatchUpdateDetectorCommand;
}($Command));
export { BatchUpdateDetectorCommand };
