import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeAlarmRequest, DescribeAlarmResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeAlarmCommand, serializeAws_restJson1DescribeAlarmCommand, } from "../protocols/Aws_restJson1";
var DescribeAlarmCommand = (function (_super) {
    __extends(DescribeAlarmCommand, _super);
    function DescribeAlarmCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeAlarmCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "DescribeAlarmCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeAlarmRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeAlarmResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeAlarmCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeAlarmCommand(input, context);
    };
    DescribeAlarmCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeAlarmCommand(output, context);
    };
    return DescribeAlarmCommand;
}($Command));
export { DescribeAlarmCommand };
