import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeDetectorRequest, DescribeDetectorResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeDetectorCommand, serializeAws_restJson1DescribeDetectorCommand, } from "../protocols/Aws_restJson1";
var DescribeDetectorCommand = (function (_super) {
    __extends(DescribeDetectorCommand, _super);
    function DescribeDetectorCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeDetectorCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "DescribeDetectorCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeDetectorRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeDetectorResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeDetectorCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeDetectorCommand(input, context);
    };
    DescribeDetectorCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeDetectorCommand(output, context);
    };
    return DescribeDetectorCommand;
}($Command));
export { DescribeDetectorCommand };
