import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListAlarmsRequest, ListAlarmsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListAlarmsCommand, serializeAws_restJson1ListAlarmsCommand, } from "../protocols/Aws_restJson1";
var ListAlarmsCommand = (function (_super) {
    __extends(ListAlarmsCommand, _super);
    function ListAlarmsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListAlarmsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "ListAlarmsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListAlarmsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListAlarmsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListAlarmsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListAlarmsCommand(input, context);
    };
    ListAlarmsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListAlarmsCommand(output, context);
    };
    return ListAlarmsCommand;
}($Command));
export { ListAlarmsCommand };
