import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListDetectorsRequest, ListDetectorsResponse } from "../models/models_0";
import { deserializeAws_restJson1ListDetectorsCommand, serializeAws_restJson1ListDetectorsCommand, } from "../protocols/Aws_restJson1";
var ListDetectorsCommand = (function (_super) {
    __extends(ListDetectorsCommand, _super);
    function ListDetectorsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListDetectorsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "IoTEventsDataClient";
        var commandName = "ListDetectorsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListDetectorsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListDetectorsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListDetectorsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListDetectorsCommand(input, context);
    };
    ListDetectorsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListDetectorsCommand(output, context);
    };
    return ListDetectorsCommand;
}($Command));
export { ListDetectorsCommand };
