import { __assign, __awaiter, __generator } from "tslib";
import { HttpRequest as __HttpRequest } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectInt32 as __expectInt32, expectNonNull as __expectNonNull, expectNumber as __expectNumber, expectObject as __expectObject, expectString as __expectString, extendedEncodeURIComponent as __extendedEncodeURIComponent, parseEpochTimestamp as __parseEpochTimestamp, } from "@aws-sdk/smithy-client";
import { IoTEventsDataServiceException as __BaseException } from "../models/IoTEventsDataServiceException";
import { InternalFailureException, InvalidRequestException, ResourceNotFoundException, ServiceUnavailableException, ThrottlingException, } from "../models/models_0";
export var serializeAws_restJson1BatchAcknowledgeAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/acknowledge";
                body = JSON.stringify(__assign({}, (input.acknowledgeActionRequests !== undefined &&
                    input.acknowledgeActionRequests !== null && {
                    acknowledgeActionRequests: serializeAws_restJson1AcknowledgeAlarmActionRequests(input.acknowledgeActionRequests, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchDisableAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/disable";
                body = JSON.stringify(__assign({}, (input.disableActionRequests !== undefined &&
                    input.disableActionRequests !== null && {
                    disableActionRequests: serializeAws_restJson1DisableAlarmActionRequests(input.disableActionRequests, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchEnableAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/enable";
                body = JSON.stringify(__assign({}, (input.enableActionRequests !== undefined &&
                    input.enableActionRequests !== null && {
                    enableActionRequests: serializeAws_restJson1EnableAlarmActionRequests(input.enableActionRequests, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchPutMessageCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/inputs/messages";
                body = JSON.stringify(__assign({}, (input.messages !== undefined &&
                    input.messages !== null && { messages: serializeAws_restJson1Messages(input.messages, context) })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchResetAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/reset";
                body = JSON.stringify(__assign({}, (input.resetActionRequests !== undefined &&
                    input.resetActionRequests !== null && {
                    resetActionRequests: serializeAws_restJson1ResetAlarmActionRequests(input.resetActionRequests, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchSnoozeAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/snooze";
                body = JSON.stringify(__assign({}, (input.snoozeActionRequests !== undefined &&
                    input.snoozeActionRequests !== null && {
                    snoozeActionRequests: serializeAws_restJson1SnoozeAlarmActionRequests(input.snoozeActionRequests, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1BatchUpdateDetectorCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {
                    "content-type": "application/json",
                };
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/detectors";
                body = JSON.stringify(__assign({}, (input.detectors !== undefined &&
                    input.detectors !== null && {
                    detectors: serializeAws_restJson1UpdateDetectorRequests(input.detectors, context),
                })));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "POST",
                        headers: headers,
                        path: resolvedPath,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DescribeAlarmCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/{alarmModelName}/keyValues";
                if (input.alarmModelName !== undefined) {
                    labelValue = input.alarmModelName;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: alarmModelName.");
                    }
                    resolvedPath = resolvedPath.replace("{alarmModelName}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: alarmModelName.");
                }
                query = __assign({}, (input.keyValue !== undefined && { keyValue: input.keyValue }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1DescribeDetectorCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/detectors/{detectorModelName}/keyValues";
                if (input.detectorModelName !== undefined) {
                    labelValue = input.detectorModelName;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: detectorModelName.");
                    }
                    resolvedPath = resolvedPath.replace("{detectorModelName}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: detectorModelName.");
                }
                query = __assign({}, (input.keyValue !== undefined && { keyValue: input.keyValue }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListAlarmsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/alarms/{alarmModelName}";
                if (input.alarmModelName !== undefined) {
                    labelValue = input.alarmModelName;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: alarmModelName.");
                    }
                    resolvedPath = resolvedPath.replace("{alarmModelName}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: alarmModelName.");
                }
                query = __assign(__assign({}, (input.nextToken !== undefined && { nextToken: input.nextToken })), (input.maxResults !== undefined && { maxResults: input.maxResults.toString() }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var serializeAws_restJson1ListDetectorsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, headers, resolvedPath, labelValue, query, body;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                headers = {};
                resolvedPath = "".concat((basePath === null || basePath === void 0 ? void 0 : basePath.endsWith("/")) ? basePath.slice(0, -1) : basePath || "") + "/detectors/{detectorModelName}";
                if (input.detectorModelName !== undefined) {
                    labelValue = input.detectorModelName;
                    if (labelValue.length <= 0) {
                        throw new Error("Empty value provided for input HTTP label: detectorModelName.");
                    }
                    resolvedPath = resolvedPath.replace("{detectorModelName}", __extendedEncodeURIComponent(labelValue));
                }
                else {
                    throw new Error("No value provided for input HTTP label: detectorModelName.");
                }
                query = __assign(__assign(__assign({}, (input.stateName !== undefined && { stateName: input.stateName })), (input.nextToken !== undefined && { nextToken: input.nextToken })), (input.maxResults !== undefined && { maxResults: input.maxResults.toString() }));
                return [2, new __HttpRequest({
                        protocol: protocol,
                        hostname: hostname,
                        port: port,
                        method: "GET",
                        headers: headers,
                        path: resolvedPath,
                        query: query,
                        body: body,
                    })];
        }
    });
}); };
export var deserializeAws_restJson1BatchAcknowledgeAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchAcknowledgeAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    errorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.errorEntries !== undefined && data.errorEntries !== null) {
                    contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchAcknowledgeAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchDisableAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchDisableAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    errorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.errorEntries !== undefined && data.errorEntries !== null) {
                    contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchDisableAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchEnableAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchEnableAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    errorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.errorEntries !== undefined && data.errorEntries !== null) {
                    contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchEnableAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchPutMessageCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchPutMessageCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    BatchPutMessageErrorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.BatchPutMessageErrorEntries !== undefined && data.BatchPutMessageErrorEntries !== null) {
                    contents.BatchPutMessageErrorEntries = deserializeAws_restJson1BatchPutMessageErrorEntries(data.BatchPutMessageErrorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchPutMessageCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchResetAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchResetAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    errorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.errorEntries !== undefined && data.errorEntries !== null) {
                    contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchResetAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchSnoozeAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 202 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchSnoozeAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    errorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.errorEntries !== undefined && data.errorEntries !== null) {
                    contents.errorEntries = deserializeAws_restJson1BatchAlarmActionErrorEntries(data.errorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchSnoozeAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1BatchUpdateDetectorCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1BatchUpdateDetectorCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    batchUpdateDetectorErrorEntries: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.batchUpdateDetectorErrorEntries !== undefined && data.batchUpdateDetectorErrorEntries !== null) {
                    contents.batchUpdateDetectorErrorEntries = deserializeAws_restJson1BatchUpdateDetectorErrorEntries(data.batchUpdateDetectorErrorEntries, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1BatchUpdateDetectorCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ServiceUnavailableException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DescribeAlarmCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DescribeAlarmCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    alarm: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.alarm !== undefined && data.alarm !== null) {
                    contents.alarm = deserializeAws_restJson1Alarm(data.alarm, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DescribeAlarmCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ResourceNotFoundException": return [3, 6];
                    case "ServiceUnavailableException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1DescribeDetectorCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1DescribeDetectorCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    detector: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.detector !== undefined && data.detector !== null) {
                    contents.detector = deserializeAws_restJson1Detector(data.detector, context);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1DescribeDetectorCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ResourceNotFoundException": return [3, 6];
                    case "ServiceUnavailableException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListAlarmsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListAlarmsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    alarmSummaries: undefined,
                    nextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.alarmSummaries !== undefined && data.alarmSummaries !== null) {
                    contents.alarmSummaries = deserializeAws_restJson1AlarmSummaries(data.alarmSummaries, context);
                }
                if (data.nextToken !== undefined && data.nextToken !== null) {
                    contents.nextToken = __expectString(data.nextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListAlarmsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ResourceNotFoundException": return [3, 6];
                    case "ServiceUnavailableException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_restJson1ListDetectorsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (output.statusCode !== 200 && output.statusCode >= 300) {
                    return [2, deserializeAws_restJson1ListDetectorsCommandError(output, context)];
                }
                contents = {
                    $metadata: deserializeMetadata(output),
                    detectorSummaries: undefined,
                    nextToken: undefined,
                };
                _a = __expectNonNull;
                _b = __expectObject;
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.apply(void 0, [_b.apply(void 0, [_c.sent()]), "body"]);
                if (data.detectorSummaries !== undefined && data.detectorSummaries !== null) {
                    contents.detectorSummaries = deserializeAws_restJson1DetectorSummaries(data.detectorSummaries, context);
                }
                if (data.nextToken !== undefined && data.nextToken !== null) {
                    contents.nextToken = __expectString(data.nextToken);
                }
                return [2, Promise.resolve(contents)];
        }
    });
}); };
var deserializeAws_restJson1ListDetectorsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalFailureException": return [3, 2];
                    case "com.amazonaws.ioteventsdata#InternalFailureException": return [3, 2];
                    case "InvalidRequestException": return [3, 4];
                    case "com.amazonaws.ioteventsdata#InvalidRequestException": return [3, 4];
                    case "ResourceNotFoundException": return [3, 6];
                    case "com.amazonaws.ioteventsdata#ResourceNotFoundException": return [3, 6];
                    case "ServiceUnavailableException": return [3, 8];
                    case "com.amazonaws.ioteventsdata#ServiceUnavailableException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.ioteventsdata#ThrottlingException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_restJson1InternalFailureExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_restJson1InvalidRequestExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_restJson1ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_restJson1ServiceUnavailableExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_restJson1ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
var deserializeAws_restJson1InternalFailureExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.message !== undefined && data.message !== null) {
            contents.message = __expectString(data.message);
        }
        exception = new InternalFailureException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1InvalidRequestExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.message !== undefined && data.message !== null) {
            contents.message = __expectString(data.message);
        }
        exception = new InvalidRequestException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ResourceNotFoundExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.message !== undefined && data.message !== null) {
            contents.message = __expectString(data.message);
        }
        exception = new ResourceNotFoundException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ServiceUnavailableExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.message !== undefined && data.message !== null) {
            contents.message = __expectString(data.message);
        }
        exception = new ServiceUnavailableException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var deserializeAws_restJson1ThrottlingExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var contents, data, exception;
    return __generator(this, function (_a) {
        contents = {};
        data = parsedOutput.body;
        if (data.message !== undefined && data.message !== null) {
            contents.message = __expectString(data.message);
        }
        exception = new ThrottlingException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, contents));
        return [2, __decorateServiceException(exception, parsedOutput.body)];
    });
}); };
var serializeAws_restJson1AcknowledgeAlarmActionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.alarmModelName !== undefined &&
        input.alarmModelName !== null && { alarmModelName: input.alarmModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.note !== undefined && input.note !== null && { note: input.note })), (input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }));
};
var serializeAws_restJson1AcknowledgeAlarmActionRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1AcknowledgeAlarmActionRequest(entry, context);
    });
};
var serializeAws_restJson1DetectorStateDefinition = function (input, context) {
    return __assign(__assign(__assign({}, (input.stateName !== undefined && input.stateName !== null && { stateName: input.stateName })), (input.timers !== undefined &&
        input.timers !== null && { timers: serializeAws_restJson1TimerDefinitions(input.timers, context) })), (input.variables !== undefined &&
        input.variables !== null && { variables: serializeAws_restJson1VariableDefinitions(input.variables, context) }));
};
var serializeAws_restJson1DisableAlarmActionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.alarmModelName !== undefined &&
        input.alarmModelName !== null && { alarmModelName: input.alarmModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.note !== undefined && input.note !== null && { note: input.note })), (input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }));
};
var serializeAws_restJson1DisableAlarmActionRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1DisableAlarmActionRequest(entry, context);
    });
};
var serializeAws_restJson1EnableAlarmActionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.alarmModelName !== undefined &&
        input.alarmModelName !== null && { alarmModelName: input.alarmModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.note !== undefined && input.note !== null && { note: input.note })), (input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }));
};
var serializeAws_restJson1EnableAlarmActionRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1EnableAlarmActionRequest(entry, context);
    });
};
var serializeAws_restJson1Message = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.inputName !== undefined && input.inputName !== null && { inputName: input.inputName })), (input.messageId !== undefined && input.messageId !== null && { messageId: input.messageId })), (input.payload !== undefined && input.payload !== null && { payload: context.base64Encoder(input.payload) })), (input.timestamp !== undefined &&
        input.timestamp !== null && { timestamp: serializeAws_restJson1TimestampValue(input.timestamp, context) }));
};
var serializeAws_restJson1Messages = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1Message(entry, context);
    });
};
var serializeAws_restJson1ResetAlarmActionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.alarmModelName !== undefined &&
        input.alarmModelName !== null && { alarmModelName: input.alarmModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.note !== undefined && input.note !== null && { note: input.note })), (input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId }));
};
var serializeAws_restJson1ResetAlarmActionRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1ResetAlarmActionRequest(entry, context);
    });
};
var serializeAws_restJson1SnoozeAlarmActionRequest = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign({}, (input.alarmModelName !== undefined &&
        input.alarmModelName !== null && { alarmModelName: input.alarmModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.note !== undefined && input.note !== null && { note: input.note })), (input.requestId !== undefined && input.requestId !== null && { requestId: input.requestId })), (input.snoozeDuration !== undefined &&
        input.snoozeDuration !== null && { snoozeDuration: input.snoozeDuration }));
};
var serializeAws_restJson1SnoozeAlarmActionRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1SnoozeAlarmActionRequest(entry, context);
    });
};
var serializeAws_restJson1TimerDefinition = function (input, context) {
    return __assign(__assign({}, (input.name !== undefined && input.name !== null && { name: input.name })), (input.seconds !== undefined && input.seconds !== null && { seconds: input.seconds }));
};
var serializeAws_restJson1TimerDefinitions = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1TimerDefinition(entry, context);
    });
};
var serializeAws_restJson1TimestampValue = function (input, context) {
    return __assign({}, (input.timeInMillis !== undefined && input.timeInMillis !== null && { timeInMillis: input.timeInMillis }));
};
var serializeAws_restJson1UpdateDetectorRequest = function (input, context) {
    return __assign(__assign(__assign(__assign({}, (input.detectorModelName !== undefined &&
        input.detectorModelName !== null && { detectorModelName: input.detectorModelName })), (input.keyValue !== undefined && input.keyValue !== null && { keyValue: input.keyValue })), (input.messageId !== undefined && input.messageId !== null && { messageId: input.messageId })), (input.state !== undefined &&
        input.state !== null && { state: serializeAws_restJson1DetectorStateDefinition(input.state, context) }));
};
var serializeAws_restJson1UpdateDetectorRequests = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1UpdateDetectorRequest(entry, context);
    });
};
var serializeAws_restJson1VariableDefinition = function (input, context) {
    return __assign(__assign({}, (input.name !== undefined && input.name !== null && { name: input.name })), (input.value !== undefined && input.value !== null && { value: input.value }));
};
var serializeAws_restJson1VariableDefinitions = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_restJson1VariableDefinition(entry, context);
    });
};
var deserializeAws_restJson1AcknowledgeActionConfiguration = function (output, context) {
    return {
        note: __expectString(output.note),
    };
};
var deserializeAws_restJson1Alarm = function (output, context) {
    return {
        alarmModelName: __expectString(output.alarmModelName),
        alarmModelVersion: __expectString(output.alarmModelVersion),
        alarmState: output.alarmState !== undefined && output.alarmState !== null
            ? deserializeAws_restJson1AlarmState(output.alarmState, context)
            : undefined,
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.creationTime)))
            : undefined,
        keyValue: __expectString(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.lastUpdateTime)))
            : undefined,
        severity: __expectInt32(output.severity),
    };
};
var deserializeAws_restJson1AlarmState = function (output, context) {
    return {
        customerAction: output.customerAction !== undefined && output.customerAction !== null
            ? deserializeAws_restJson1CustomerAction(output.customerAction, context)
            : undefined,
        ruleEvaluation: output.ruleEvaluation !== undefined && output.ruleEvaluation !== null
            ? deserializeAws_restJson1RuleEvaluation(output.ruleEvaluation, context)
            : undefined,
        stateName: __expectString(output.stateName),
        systemEvent: output.systemEvent !== undefined && output.systemEvent !== null
            ? deserializeAws_restJson1SystemEvent(output.systemEvent, context)
            : undefined,
    };
};
var deserializeAws_restJson1AlarmSummaries = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1AlarmSummary(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1AlarmSummary = function (output, context) {
    return {
        alarmModelName: __expectString(output.alarmModelName),
        alarmModelVersion: __expectString(output.alarmModelVersion),
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.creationTime)))
            : undefined,
        keyValue: __expectString(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.lastUpdateTime)))
            : undefined,
        stateName: __expectString(output.stateName),
    };
};
var deserializeAws_restJson1BatchAlarmActionErrorEntries = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchAlarmActionErrorEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1BatchAlarmActionErrorEntry = function (output, context) {
    return {
        errorCode: __expectString(output.errorCode),
        errorMessage: __expectString(output.errorMessage),
        requestId: __expectString(output.requestId),
    };
};
var deserializeAws_restJson1BatchPutMessageErrorEntries = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchPutMessageErrorEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1BatchPutMessageErrorEntry = function (output, context) {
    return {
        errorCode: __expectString(output.errorCode),
        errorMessage: __expectString(output.errorMessage),
        messageId: __expectString(output.messageId),
    };
};
var deserializeAws_restJson1BatchUpdateDetectorErrorEntries = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1BatchUpdateDetectorErrorEntry(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1BatchUpdateDetectorErrorEntry = function (output, context) {
    return {
        errorCode: __expectString(output.errorCode),
        errorMessage: __expectString(output.errorMessage),
        messageId: __expectString(output.messageId),
    };
};
var deserializeAws_restJson1CustomerAction = function (output, context) {
    return {
        acknowledgeActionConfiguration: output.acknowledgeActionConfiguration !== undefined && output.acknowledgeActionConfiguration !== null
            ? deserializeAws_restJson1AcknowledgeActionConfiguration(output.acknowledgeActionConfiguration, context)
            : undefined,
        actionName: __expectString(output.actionName),
        disableActionConfiguration: output.disableActionConfiguration !== undefined && output.disableActionConfiguration !== null
            ? deserializeAws_restJson1DisableActionConfiguration(output.disableActionConfiguration, context)
            : undefined,
        enableActionConfiguration: output.enableActionConfiguration !== undefined && output.enableActionConfiguration !== null
            ? deserializeAws_restJson1EnableActionConfiguration(output.enableActionConfiguration, context)
            : undefined,
        resetActionConfiguration: output.resetActionConfiguration !== undefined && output.resetActionConfiguration !== null
            ? deserializeAws_restJson1ResetActionConfiguration(output.resetActionConfiguration, context)
            : undefined,
        snoozeActionConfiguration: output.snoozeActionConfiguration !== undefined && output.snoozeActionConfiguration !== null
            ? deserializeAws_restJson1SnoozeActionConfiguration(output.snoozeActionConfiguration, context)
            : undefined,
    };
};
var deserializeAws_restJson1Detector = function (output, context) {
    return {
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.creationTime)))
            : undefined,
        detectorModelName: __expectString(output.detectorModelName),
        detectorModelVersion: __expectString(output.detectorModelVersion),
        keyValue: __expectString(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.lastUpdateTime)))
            : undefined,
        state: output.state !== undefined && output.state !== null
            ? deserializeAws_restJson1DetectorState(output.state, context)
            : undefined,
    };
};
var deserializeAws_restJson1DetectorState = function (output, context) {
    return {
        stateName: __expectString(output.stateName),
        timers: output.timers !== undefined && output.timers !== null
            ? deserializeAws_restJson1Timers(output.timers, context)
            : undefined,
        variables: output.variables !== undefined && output.variables !== null
            ? deserializeAws_restJson1Variables(output.variables, context)
            : undefined,
    };
};
var deserializeAws_restJson1DetectorStateSummary = function (output, context) {
    return {
        stateName: __expectString(output.stateName),
    };
};
var deserializeAws_restJson1DetectorSummaries = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1DetectorSummary(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1DetectorSummary = function (output, context) {
    return {
        creationTime: output.creationTime !== undefined && output.creationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.creationTime)))
            : undefined,
        detectorModelName: __expectString(output.detectorModelName),
        detectorModelVersion: __expectString(output.detectorModelVersion),
        keyValue: __expectString(output.keyValue),
        lastUpdateTime: output.lastUpdateTime !== undefined && output.lastUpdateTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.lastUpdateTime)))
            : undefined,
        state: output.state !== undefined && output.state !== null
            ? deserializeAws_restJson1DetectorStateSummary(output.state, context)
            : undefined,
    };
};
var deserializeAws_restJson1DisableActionConfiguration = function (output, context) {
    return {
        note: __expectString(output.note),
    };
};
var deserializeAws_restJson1EnableActionConfiguration = function (output, context) {
    return {
        note: __expectString(output.note),
    };
};
var deserializeAws_restJson1ResetActionConfiguration = function (output, context) {
    return {
        note: __expectString(output.note),
    };
};
var deserializeAws_restJson1RuleEvaluation = function (output, context) {
    return {
        simpleRuleEvaluation: output.simpleRuleEvaluation !== undefined && output.simpleRuleEvaluation !== null
            ? deserializeAws_restJson1SimpleRuleEvaluation(output.simpleRuleEvaluation, context)
            : undefined,
    };
};
var deserializeAws_restJson1SimpleRuleEvaluation = function (output, context) {
    return {
        inputPropertyValue: __expectString(output.inputPropertyValue),
        operator: __expectString(output.operator),
        thresholdValue: __expectString(output.thresholdValue),
    };
};
var deserializeAws_restJson1SnoozeActionConfiguration = function (output, context) {
    return {
        note: __expectString(output.note),
        snoozeDuration: __expectInt32(output.snoozeDuration),
    };
};
var deserializeAws_restJson1StateChangeConfiguration = function (output, context) {
    return {
        triggerType: __expectString(output.triggerType),
    };
};
var deserializeAws_restJson1SystemEvent = function (output, context) {
    return {
        eventType: __expectString(output.eventType),
        stateChangeConfiguration: output.stateChangeConfiguration !== undefined && output.stateChangeConfiguration !== null
            ? deserializeAws_restJson1StateChangeConfiguration(output.stateChangeConfiguration, context)
            : undefined,
    };
};
var deserializeAws_restJson1Timer = function (output, context) {
    return {
        name: __expectString(output.name),
        timestamp: output.timestamp !== undefined && output.timestamp !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.timestamp)))
            : undefined,
    };
};
var deserializeAws_restJson1Timers = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Timer(entry, context);
    });
    return retVal;
};
var deserializeAws_restJson1Variable = function (output, context) {
    return {
        name: __expectString(output.name),
        value: __expectString(output.value),
    };
};
var deserializeAws_restJson1Variables = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_restJson1Variable(entry, context);
    });
    return retVal;
};
var deserializeMetadata = function (output) {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
var collectBody = function (streamBody, context) {
    if (streamBody === void 0) { streamBody = new Uint8Array(); }
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
var collectBodyString = function (streamBody, context) {
    return collectBody(streamBody, context).then(function (body) { return context.utf8Encoder(body); });
};
var isSerializableHeaderValue = function (value) {
    return value !== undefined &&
        value !== null &&
        value !== "" &&
        (!Object.getOwnPropertyNames(value).includes("length") || value.length != 0) &&
        (!Object.getOwnPropertyNames(value).includes("size") || value.size != 0);
};
var parseBody = function (streamBody, context) {
    return collectBodyString(streamBody, context).then(function (encoded) {
        if (encoded.length) {
            return JSON.parse(encoded);
        }
        return {};
    });
};
var loadRestJsonErrorCode = function (output, data) {
    var findKey = function (object, key) { return Object.keys(object).find(function (k) { return k.toLowerCase() === key.toLowerCase(); }); };
    var sanitizeErrorCode = function (rawValue) {
        var cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    var headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
