import { HttpHandlerOptions as __HttpHandlerOptions } from "@aws-sdk/types";
import { BatchAcknowledgeAlarmCommandInput, BatchAcknowledgeAlarmCommandOutput } from "./commands/BatchAcknowledgeAlarmCommand";
import { BatchDisableAlarmCommandInput, BatchDisableAlarmCommandOutput } from "./commands/BatchDisableAlarmCommand";
import { BatchEnableAlarmCommandInput, BatchEnableAlarmCommandOutput } from "./commands/BatchEnableAlarmCommand";
import { BatchPutMessageCommandInput, BatchPutMessageCommandOutput } from "./commands/BatchPutMessageCommand";
import { BatchResetAlarmCommandInput, BatchResetAlarmCommandOutput } from "./commands/BatchResetAlarmCommand";
import { BatchSnoozeAlarmCommandInput, BatchSnoozeAlarmCommandOutput } from "./commands/BatchSnoozeAlarmCommand";
import { BatchUpdateDetectorCommandInput, BatchUpdateDetectorCommandOutput } from "./commands/BatchUpdateDetectorCommand";
import { DescribeAlarmCommandInput, DescribeAlarmCommandOutput } from "./commands/DescribeAlarmCommand";
import { DescribeDetectorCommandInput, DescribeDetectorCommandOutput } from "./commands/DescribeDetectorCommand";
import { ListAlarmsCommandInput, ListAlarmsCommandOutput } from "./commands/ListAlarmsCommand";
import { ListDetectorsCommandInput, ListDetectorsCommandOutput } from "./commands/ListDetectorsCommand";
import { IoTEventsDataClient } from "./IoTEventsDataClient";

export declare class IoTEventsData extends IoTEventsDataClient {
    
    batchAcknowledgeAlarm(args: BatchAcknowledgeAlarmCommandInput, options?: __HttpHandlerOptions): Promise<BatchAcknowledgeAlarmCommandOutput>;
    batchAcknowledgeAlarm(args: BatchAcknowledgeAlarmCommandInput, cb: (err: any, data?: BatchAcknowledgeAlarmCommandOutput) => void): void;
    batchAcknowledgeAlarm(args: BatchAcknowledgeAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchAcknowledgeAlarmCommandOutput) => void): void;
    
    batchDisableAlarm(args: BatchDisableAlarmCommandInput, options?: __HttpHandlerOptions): Promise<BatchDisableAlarmCommandOutput>;
    batchDisableAlarm(args: BatchDisableAlarmCommandInput, cb: (err: any, data?: BatchDisableAlarmCommandOutput) => void): void;
    batchDisableAlarm(args: BatchDisableAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchDisableAlarmCommandOutput) => void): void;
    
    batchEnableAlarm(args: BatchEnableAlarmCommandInput, options?: __HttpHandlerOptions): Promise<BatchEnableAlarmCommandOutput>;
    batchEnableAlarm(args: BatchEnableAlarmCommandInput, cb: (err: any, data?: BatchEnableAlarmCommandOutput) => void): void;
    batchEnableAlarm(args: BatchEnableAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchEnableAlarmCommandOutput) => void): void;
    
    batchPutMessage(args: BatchPutMessageCommandInput, options?: __HttpHandlerOptions): Promise<BatchPutMessageCommandOutput>;
    batchPutMessage(args: BatchPutMessageCommandInput, cb: (err: any, data?: BatchPutMessageCommandOutput) => void): void;
    batchPutMessage(args: BatchPutMessageCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchPutMessageCommandOutput) => void): void;
    
    batchResetAlarm(args: BatchResetAlarmCommandInput, options?: __HttpHandlerOptions): Promise<BatchResetAlarmCommandOutput>;
    batchResetAlarm(args: BatchResetAlarmCommandInput, cb: (err: any, data?: BatchResetAlarmCommandOutput) => void): void;
    batchResetAlarm(args: BatchResetAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchResetAlarmCommandOutput) => void): void;
    
    batchSnoozeAlarm(args: BatchSnoozeAlarmCommandInput, options?: __HttpHandlerOptions): Promise<BatchSnoozeAlarmCommandOutput>;
    batchSnoozeAlarm(args: BatchSnoozeAlarmCommandInput, cb: (err: any, data?: BatchSnoozeAlarmCommandOutput) => void): void;
    batchSnoozeAlarm(args: BatchSnoozeAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchSnoozeAlarmCommandOutput) => void): void;
    
    batchUpdateDetector(args: BatchUpdateDetectorCommandInput, options?: __HttpHandlerOptions): Promise<BatchUpdateDetectorCommandOutput>;
    batchUpdateDetector(args: BatchUpdateDetectorCommandInput, cb: (err: any, data?: BatchUpdateDetectorCommandOutput) => void): void;
    batchUpdateDetector(args: BatchUpdateDetectorCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: BatchUpdateDetectorCommandOutput) => void): void;
    
    describeAlarm(args: DescribeAlarmCommandInput, options?: __HttpHandlerOptions): Promise<DescribeAlarmCommandOutput>;
    describeAlarm(args: DescribeAlarmCommandInput, cb: (err: any, data?: DescribeAlarmCommandOutput) => void): void;
    describeAlarm(args: DescribeAlarmCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DescribeAlarmCommandOutput) => void): void;
    
    describeDetector(args: DescribeDetectorCommandInput, options?: __HttpHandlerOptions): Promise<DescribeDetectorCommandOutput>;
    describeDetector(args: DescribeDetectorCommandInput, cb: (err: any, data?: DescribeDetectorCommandOutput) => void): void;
    describeDetector(args: DescribeDetectorCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DescribeDetectorCommandOutput) => void): void;
    
    listAlarms(args: ListAlarmsCommandInput, options?: __HttpHandlerOptions): Promise<ListAlarmsCommandOutput>;
    listAlarms(args: ListAlarmsCommandInput, cb: (err: any, data?: ListAlarmsCommandOutput) => void): void;
    listAlarms(args: ListAlarmsCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: ListAlarmsCommandOutput) => void): void;
    
    listDetectors(args: ListDetectorsCommandInput, options?: __HttpHandlerOptions): Promise<ListDetectorsCommandOutput>;
    listDetectors(args: ListDetectorsCommandInput, cb: (err: any, data?: ListDetectorsCommandOutput) => void): void;
    listDetectors(args: ListDetectorsCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: ListDetectorsCommandOutput) => void): void;
}
