import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchAcknowledgeAlarmRequest, BatchAcknowledgeAlarmResponse } from "../models/models_0";
export interface BatchAcknowledgeAlarmCommandInput extends BatchAcknowledgeAlarmRequest {
}
export interface BatchAcknowledgeAlarmCommandOutput extends BatchAcknowledgeAlarmResponse, __MetadataBearer {
}

export declare class BatchAcknowledgeAlarmCommand extends $Command<BatchAcknowledgeAlarmCommandInput, BatchAcknowledgeAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchAcknowledgeAlarmCommandInput;
    constructor(input: BatchAcknowledgeAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchAcknowledgeAlarmCommandInput, BatchAcknowledgeAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
