import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchDisableAlarmRequest, BatchDisableAlarmResponse } from "../models/models_0";
export interface BatchDisableAlarmCommandInput extends BatchDisableAlarmRequest {
}
export interface BatchDisableAlarmCommandOutput extends BatchDisableAlarmResponse, __MetadataBearer {
}

export declare class BatchDisableAlarmCommand extends $Command<BatchDisableAlarmCommandInput, BatchDisableAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchDisableAlarmCommandInput;
    constructor(input: BatchDisableAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchDisableAlarmCommandInput, BatchDisableAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
