import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchEnableAlarmRequest, BatchEnableAlarmResponse } from "../models/models_0";
export interface BatchEnableAlarmCommandInput extends BatchEnableAlarmRequest {
}
export interface BatchEnableAlarmCommandOutput extends BatchEnableAlarmResponse, __MetadataBearer {
}

export declare class BatchEnableAlarmCommand extends $Command<BatchEnableAlarmCommandInput, BatchEnableAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchEnableAlarmCommandInput;
    constructor(input: BatchEnableAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchEnableAlarmCommandInput, BatchEnableAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
