import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchPutMessageRequest, BatchPutMessageResponse } from "../models/models_0";
export interface BatchPutMessageCommandInput extends BatchPutMessageRequest {
}
export interface BatchPutMessageCommandOutput extends BatchPutMessageResponse, __MetadataBearer {
}

export declare class BatchPutMessageCommand extends $Command<BatchPutMessageCommandInput, BatchPutMessageCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchPutMessageCommandInput;
    constructor(input: BatchPutMessageCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchPutMessageCommandInput, BatchPutMessageCommandOutput>;
    private serialize;
    private deserialize;
}
