import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchResetAlarmRequest, BatchResetAlarmResponse } from "../models/models_0";
export interface BatchResetAlarmCommandInput extends BatchResetAlarmRequest {
}
export interface BatchResetAlarmCommandOutput extends BatchResetAlarmResponse, __MetadataBearer {
}

export declare class BatchResetAlarmCommand extends $Command<BatchResetAlarmCommandInput, BatchResetAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchResetAlarmCommandInput;
    constructor(input: BatchResetAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchResetAlarmCommandInput, BatchResetAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
