import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchSnoozeAlarmRequest, BatchSnoozeAlarmResponse } from "../models/models_0";
export interface BatchSnoozeAlarmCommandInput extends BatchSnoozeAlarmRequest {
}
export interface BatchSnoozeAlarmCommandOutput extends BatchSnoozeAlarmResponse, __MetadataBearer {
}

export declare class BatchSnoozeAlarmCommand extends $Command<BatchSnoozeAlarmCommandInput, BatchSnoozeAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchSnoozeAlarmCommandInput;
    constructor(input: BatchSnoozeAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchSnoozeAlarmCommandInput, BatchSnoozeAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
