import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { BatchUpdateDetectorRequest, BatchUpdateDetectorResponse } from "../models/models_0";
export interface BatchUpdateDetectorCommandInput extends BatchUpdateDetectorRequest {
}
export interface BatchUpdateDetectorCommandOutput extends BatchUpdateDetectorResponse, __MetadataBearer {
}

export declare class BatchUpdateDetectorCommand extends $Command<BatchUpdateDetectorCommandInput, BatchUpdateDetectorCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: BatchUpdateDetectorCommandInput;
    constructor(input: BatchUpdateDetectorCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<BatchUpdateDetectorCommandInput, BatchUpdateDetectorCommandOutput>;
    private serialize;
    private deserialize;
}
