import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { DescribeAlarmRequest, DescribeAlarmResponse } from "../models/models_0";
export interface DescribeAlarmCommandInput extends DescribeAlarmRequest {
}
export interface DescribeAlarmCommandOutput extends DescribeAlarmResponse, __MetadataBearer {
}

export declare class DescribeAlarmCommand extends $Command<DescribeAlarmCommandInput, DescribeAlarmCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: DescribeAlarmCommandInput;
    constructor(input: DescribeAlarmCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeAlarmCommandInput, DescribeAlarmCommandOutput>;
    private serialize;
    private deserialize;
}
