import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { ListAlarmsRequest, ListAlarmsResponse } from "../models/models_0";
export interface ListAlarmsCommandInput extends ListAlarmsRequest {
}
export interface ListAlarmsCommandOutput extends ListAlarmsResponse, __MetadataBearer {
}

export declare class ListAlarmsCommand extends $Command<ListAlarmsCommandInput, ListAlarmsCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: ListAlarmsCommandInput;
    constructor(input: ListAlarmsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListAlarmsCommandInput, ListAlarmsCommandOutput>;
    private serialize;
    private deserialize;
}
