import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { IoTEventsDataClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../IoTEventsDataClient";
import { ListDetectorsRequest, ListDetectorsResponse } from "../models/models_0";
export interface ListDetectorsCommandInput extends ListDetectorsRequest {
}
export interface ListDetectorsCommandOutput extends ListDetectorsResponse, __MetadataBearer {
}

export declare class ListDetectorsCommand extends $Command<ListDetectorsCommandInput, ListDetectorsCommandOutput, IoTEventsDataClientResolvedConfig> {
    readonly input: ListDetectorsCommandInput;
    constructor(input: ListDetectorsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: IoTEventsDataClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDetectorsCommandInput, ListDetectorsCommandOutput>;
    private serialize;
    private deserialize;
}
